package v1;

import javax.swing.*;
import java.awt.*;
import javax.swing.event.*;
import java.awt.event.*;
import java.io.*;

/**
 * <p>Title: PhFit</p>
 * <p>Description: General Phase-Type Fitting Tool</p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: </p>
 * @author Andr\uFFFDs Horv\uFFFDth
 * @version 1.0
 */

public class PhFitFrame_CreateBox extends JDialog {
  JLabel jYMinimumLabel = new JLabel();
  JTextField jYMinimumField = new JTextField();
  JButton jAxisButton = new JButton();
  JLabel jXNumofPointsLabel = new JLabel();
  JTextField jXNumofPointsField = new JTextField();
  JTextField jYMaximumField = new JTextField();
  JLabel jYMaximumLabel = new JLabel();
  JCheckBox jYAutomaticBox = new JCheckBox();
  JTextField jXMinimumField = new JTextField();
  JLabel jXMinimumLabel = new JLabel();
  JLabel jXMaximumLabel = new JLabel();
  JTextField jXMaximumField = new JTextField();
  JPanel jPanel3 = new JPanel();
  JPanel jPanel1 = new JPanel();

  boolean PHFamily;
  int DistFamily;
  int imagecounter;
  int curvetype;
  String Param1;
  String Param2;
  boolean dm;
  double minimumx;
  double maximumx;
  int numofpoints;
  boolean lx;
  boolean ly;
  double ScaleFactor;

  JCheckBox jLogXScaleBox = new JCheckBox();
  JCheckBox jLogYScaleBox = new JCheckBox();

  // ---------------
  // Execute command
  private int execProcess(String commandLine)
    {
	try
	    {
		System.out.println("trying to exec: " + commandLine);
		Process p = Runtime.getRuntime().exec(commandLine);

		BufferedReader b = new BufferedReader(
                  new InputStreamReader(p.getInputStream()));
		String l;
		while ((l = b.readLine()) != null)
		    {
			//Debug.message("server.exec",l);
		    }

		int ExitVal = p.waitFor();
		System.out.println("terminate with: " + ExitVal);
		return ExitVal;
	    }
	catch (Exception e)
	    {
		System.out.println("Error: " + e.getMessage());
		return ERROR;
	    }
    } // of execProcess


  public PhFitFrame_CreateBox(boolean PHF, int DF, String p1, String p2,
    int ic, int ct, boolean demomode, double minx, double maxx,
    int numofx, boolean logx, boolean logy, double sf) {

    try {

      PHFamily=PHF;
      DistFamily=DF;
      Param1=p1;
      Param2=p2;
      imagecounter=ic;
      curvetype=ct;
      dm=demomode;
      minimumx=minx;
      maximumx=maxx;
      numofpoints=numofx;
      lx=logx;
      ly=logy;
      ScaleFactor=sf;

      jbInit();
      //pack();
      setLocation(100,100);
      setSize(290,290);
      setModal(true);
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }
  private void jbInit() throws Exception {
    this.getContentPane().setLayout(null);
    jYMinimumLabel.setForeground(Color.gray);
    jYMinimumLabel.setText("Minimum of y-axis:");
    jYMinimumLabel.setBounds(new Rectangle(59, 113, 128, 17));
    jYMinimumField.setEnabled(false);
    jYMinimumField.setBounds(new Rectangle(184, 110, 63, 21));
    jAxisButton.setText("Ok");
    jAxisButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jAxisButton_actionPerformed(e);
      }
    });
    jAxisButton.setBounds(new Rectangle(185, 212, 61, 22));
    jXNumofPointsLabel.setBounds(new Rectangle(4, 54, 185, 17));
    jXNumofPointsLabel.setText("Number of points on x-axis:");
    jXNumofPointsField.setBounds(new Rectangle(188, 53, 63, 21));
    jYMaximumField.setEnabled(false);
    jYMaximumField.setBounds(new Rectangle(184, 133, 63, 21));
    jYMaximumLabel.setBounds(new Rectangle(57, 136, 128, 17));
    jYMaximumLabel.setForeground(Color.gray);
    jYMaximumLabel.setText("Maximum of y-axis:");
    jYAutomaticBox.addChangeListener(new javax.swing.event.ChangeListener() {
      public void stateChanged(ChangeEvent e) {
        jYAutomaticBox_stateChanged(e);
      }
    });
    jYAutomaticBox.setBounds(new Rectangle(21, 86, 227, 25));
    jYAutomaticBox.setText("Automatic ranges on y-axis");
    jYAutomaticBox.setSelected(true);
    jYAutomaticBox.setHorizontalAlignment(SwingConstants.TRAILING);
    jYAutomaticBox.setHorizontalTextPosition(SwingConstants.LEFT);
    jXMinimumField.setBounds(new Rectangle(188, 7, 63, 21));
    jXMinimumLabel.setBounds(new Rectangle(59, 8, 125, 17));
    jXMinimumLabel.setText("Minimum of x-axis:");
    jXMaximumLabel.setText("Maximum of x-axis:");
    jXMaximumLabel.setBounds(new Rectangle(57, 32, 133, 17));
    jXMaximumField.setBounds(new Rectangle(188, 30, 63, 21));
    jPanel3.setLayout(null);
    jPanel3.setBounds(new Rectangle(9, 5, 270, 254));
    jPanel3.setBorder(BorderFactory.createEtchedBorder());
    jPanel1.setBounds(new Rectangle(296, 7, 224, 247));
    jLogXScaleBox.setHorizontalTextPosition(SwingConstants.LEFT);
    jLogXScaleBox.setText("Logarithmic x-axis");
    jLogXScaleBox.setBounds(new Rectangle(111, 157, 138, 25));
    jLogYScaleBox.setBounds(new Rectangle(110, 179, 138, 25));
    jLogYScaleBox.setText("Logarithmic y-axis");
    jLogYScaleBox.setHorizontalTextPosition(SwingConstants.LEFT);
    this.addWindowListener(new java.awt.event.WindowAdapter() {
      public void windowOpened(WindowEvent e) {
        this_windowOpened(e);
      }
    });
    jPanel3.add(jYMinimumLabel, null);
    jPanel3.add(jYMaximumLabel, null);
    jPanel3.add(jXMinimumLabel, null);
    jPanel3.add(jXMaximumLabel, null);
    jPanel3.add(jXMaximumField, null);
    jPanel3.add(jXMinimumField, null);
    jPanel3.add(jXNumofPointsField, null);
    jPanel3.add(jXNumofPointsLabel, null);
    jPanel3.add(jYMinimumField, null);
    jPanel3.add(jYMaximumField, null);
    jPanel3.add(jLogXScaleBox, null);
    jPanel3.add(jYAutomaticBox, null);
    jPanel3.add(jLogYScaleBox, null);
    jPanel3.add(jAxisButton, null);
    this.getContentPane().add(jPanel1, null);
    this.getContentPane().add(jPanel3, null);
  }

  void jYAutomaticBox_stateChanged(ChangeEvent e) {
    if(jYAutomaticBox.isSelected())
      {
        jYMinimumField.setEnabled(false);
        jYMaximumField.setEnabled(false);
        jYMinimumLabel.setForeground(Color.gray);
        jYMaximumLabel.setForeground(Color.gray);
      }
    else
      {
        jYMinimumField.setEnabled(true);
        jYMaximumField.setEnabled(true);
        jYMinimumLabel.setForeground(Color.black);
        jYMaximumLabel.setForeground(Color.black);
      }
  }

  class partofademo extends Thread {

    void FlashLabel(JComponent l) {
      int base=Constants.blinkspeed;
      try {
      for(int i1=0;i1<Constants.blinknumber;i1++)
        {
          l.setForeground(Color.gray);
          this.sleep(base);
          l.setForeground(Color.black);
          this.sleep(base);
        }
      } catch (InterruptedException e){}
    }

    public void run() {
    // filling fields
    FlashLabel(jXMinimumLabel);
    jXMinimumField.setText(String.valueOf(minimumx));
    FlashLabel(jXMaximumLabel);
    jXMaximumField.setText(String.valueOf(maximumx));
    FlashLabel(jXNumofPointsLabel);
    jXNumofPointsField.setText(String.valueOf(numofpoints));
    FlashLabel(jYAutomaticBox);
    jYAutomaticBox.setSelected(true);
    FlashLabel(jLogXScaleBox);
    jLogXScaleBox.setSelected(lx);
    FlashLabel(jLogYScaleBox);
    jLogYScaleBox.setSelected(ly);

    // creating data and image
    FlashLabel(jAxisButton);
    CreateDataFile();
    CreateGnuPlotFile();
    dispose();
    }
  }

  String CreateCommandPDFCont() {
    String command;
    double stepsize;

    command="contfit 2 ";
    command=command+Integer.toString(DistFamily+1)+" ";
    command=command+Param1+" "+Param2+" ";
    command=command+jXMinimumField.getText()+" ";
    command=command+jXMaximumField.getText()+" ";

    if(jLogXScaleBox.isSelected())
      {
        if(Double.parseDouble(jXMinimumField.getText())==0.0)
          {
            stepsize=Double.parseDouble(jXMaximumField.getText());
            stepsize=stepsize-Double.parseDouble(jXMinimumField.getText());
            stepsize=stepsize/100.0;
          }
        else
          {
            stepsize=Double.parseDouble(jXMinimumField.getText());
          }
        stepsize=Double.parseDouble(jXMaximumField.getText())/stepsize;
        stepsize=Math.pow(stepsize,1.0/Double.parseDouble(jXNumofPointsField.getText()));
        command=command+"-"+String.valueOf(stepsize);
      }
    else
      {
        stepsize=Double.parseDouble(jXMaximumField.getText());
        stepsize=stepsize-Double.parseDouble(jXMinimumField.getText());
        stepsize=stepsize/Double.parseDouble(jXNumofPointsField.getText());
        command=command+String.valueOf(stepsize);
      }
    return command;
    }

  String CreateCommandPDFDisc() {
    String command;
    double stepsize;

    command="discfit 2 ";
    command=command+Integer.toString(DistFamily+1)+" ";
    command=command+Param1+" "+Param2+" ";
    command=command+jXMinimumField.getText()+" ";
    command=command+jXMaximumField.getText()+" ";

    if(jLogXScaleBox.isSelected())
      {
        if(Double.parseDouble(jXMinimumField.getText())==0.0)
          {
            stepsize=Double.parseDouble(jXMaximumField.getText());
            stepsize=stepsize-Double.parseDouble(jXMinimumField.getText());
            stepsize=stepsize/100.0;
          }
        else
          {
            stepsize=Double.parseDouble(jXMinimumField.getText());
          }
        stepsize=Double.parseDouble(jXMaximumField.getText())/stepsize;
        stepsize=Math.pow(stepsize,1.0/Double.parseDouble(jXNumofPointsField.getText()));
        command=command+"-"+String.valueOf(stepsize);
      }
    else
      {
        stepsize=Double.parseDouble(jXMaximumField.getText());
        stepsize=stepsize-Double.parseDouble(jXMinimumField.getText());
        stepsize=stepsize/Double.parseDouble(jXNumofPointsField.getText());
        command=command+String.valueOf(stepsize);
      }
    command=command+" "+String.valueOf(ScaleFactor);
    return command;
    }


  void CreateDataFile() {
    String command;

    if(PHFamily)
      {
        command=CreateCommandPDFCont();
      }
    else
      {
        command=CreateCommandPDFDisc();
      }

    execProcess(command);
  }

  void CreateGnuPlotFile() {

    // write gnuplot file
      try {
        FileOutputStream gnuplotFile = new FileOutputStream("TEMPORARYPhFitFILE.gnu");
        PrintWriter gnuplotWriter = new PrintWriter(gnuplotFile);

        gnuplotWriter.print("set xrange ["+
          String.valueOf(jXMinimumField.getText())+":"+
          String.valueOf(jXMaximumField.getText())+"]\n");
       if(jLogXScaleBox.isSelected())
         {
           gnuplotWriter.print("set logscale x\n");
         }
       if(jLogYScaleBox.isSelected())
         {
           gnuplotWriter.print("set logscale y\n");
         }
       if(!jYAutomaticBox.isSelected())
         {
           gnuplotWriter.print("set yrange ["+
             String.valueOf(jYMinimumField.getText())+":"+
             String.valueOf(jYMaximumField.getText())+"]\n");
         }
       gnuplotWriter.print("set da st lines\n");
       gnuplotWriter.print("set terminal gif transparent size 350,230\n");
       gnuplotWriter.print("set key outside reverse samplen 0.5\n");
       gnuplotWriter.print("!rm TEMPORARYPhFitImage"+
         String.valueOf(imagecounter)+".gif\n");
       gnuplotWriter.print("set out 'TEMPORARYPhFitImage"+
         String.valueOf(imagecounter)+".gif'\n");
       if(PHFamily)
        {
        if(curvetype<=5)
           {
            gnuplotWriter.print("plot 'TEMPORARYPhFitFILE.data' using 1:"+
               String.valueOf(curvetype)+" title 'Orig.'");
            gnuplotWriter.print(",'' using 1:"+
               String.valueOf(curvetype+4)+" title 'Appr.'");
          }
        else
          {
             gnuplotWriter.print("plot 'TEMPORARYPhFitFILE.data' using 1:"+
               String.valueOf(curvetype+4)+" notitle");
          }
        }
       else
        {
          switch(curvetype)
            {
            case 2:
               gnuplotWriter.print("plot 'TEMPORARYPhFitFILE.data' using 2:3 title 'Orig.'");
               gnuplotWriter.print(",'' using 1:($7/"+String.valueOf(ScaleFactor)+
                ") title 'Appr.' with lp");
               break;
            case 3:
               gnuplotWriter.print("plot 'TEMPORARYPhFitFILE.data' using 2:4 title 'Orig.'");
               gnuplotWriter.print(",'' using 1:8 title 'Appr.' with step");
              break;
            case 4:
               gnuplotWriter.print("plot 'TEMPORARYPhFitFILE.data' using 2:5 title 'Orig.'");
               gnuplotWriter.print(",'' using 1:9 title 'Appr.' with step");
              break;
            case 5:
               gnuplotWriter.print("plot 'TEMPORARYPhFitFILE.data' using 2:6 title 'Orig.'");
               gnuplotWriter.print(",'' using 1:($10/"+String.valueOf(ScaleFactor)+
                ") title 'Appr.' with lp");
              break;
            case 6:
               gnuplotWriter.print("plot 'TEMPORARYPhFitFILE.data' using 1:11 notitle");
              break;
            case 7:
               gnuplotWriter.print("plot 'TEMPORARYPhFitFILE.data' using 1:12 notitle");
               break;
            case 8:
               gnuplotWriter.print("plot 'TEMPORARYPhFitFILE.data' using 1:13 notitle");
              break;
            case 9:
               gnuplotWriter.print("plot 'TEMPORARYPhFitFILE.data' using 1:14 notitle");
              break;
            }
        }
       gnuplotWriter.print("\n set output");
       gnuplotWriter.close();
 	}
       catch (FileNotFoundException f) {}

       execProcess("gnuplot TEMPORARYPhFitFILE.gnu");
    }


  void jAxisButton_actionPerformed(ActionEvent e) {

    // Things should be checked here before actions;
    CreateDataFile();
    CreateGnuPlotFile();
    dispose();
  }

  void this_windowOpened(WindowEvent e) {
    if(dm)
      {
        partofademo p = new partofademo();
        p.start();
      }
  }
}
