package v1;

import javax.swing.*;
import java.awt.*;
import java.io.*;
import java.awt.event.*;

/**
 * <p>Title: PhFit</p>
 * <p>Description: General Phase-Type Fitting Tool</p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: </p>
 * @author Andr\uFFFDs Horv\uFFFDth
 * @version 1.0
 */

public class PhFitFrame_Messages extends JDialog {
  JScrollPane jScrollPane1 = new JScrollPane();
  JTextArea jMessagesText = new JTextArea();
  String command;
  JButton jCloseButton = new JButton();
  boolean dm,success;

  class Loader extends Thread {

    void FlashLabel(JComponent l) {
    int base=Constants.blinkspeed;
    try {
      for(int i1=0;i1<Constants.blinknumber;i1++)
        {
          l.setForeground(Color.gray);
          this.sleep(base);
          l.setForeground(Color.black);
          this.sleep(base);
        }
      } catch (InterruptedException e){}
    }

    public boolean Success()
      {
        return success;
      }

    public void run() {
    try
      {
        success=false;
        boolean FirstTime=true;
        // Here we perform the fitting as given by the String command
        jCloseButton.setEnabled(false);
        System.out.println("trying to exec: " + command);
        Process p = Runtime.getRuntime().exec(command);
        BufferedReader b = new BufferedReader(
          new InputStreamReader(p.getInputStream()));
        String l;
        while ((l = b.readLine()) != null)
          {
            if(l.startsWith("  Modification") && !FirstTime)
              {
                jMessagesText.replaceRange(l,
                  jMessagesText.getText().length()-l.length(),
                  jMessagesText.getText().length());
              }
            else
              {
                FirstTime=true;
                if(l.startsWith("  Modification"))
                  FirstTime=false;
                jMessagesText.append(l);
                jMessagesText.append("\n");
                jMessagesText.repaint();
              }
            System.out.println(l);
          }
        jCloseButton.setEnabled(true);
        int ExitVal = p.waitFor();
        if(ExitVal==0)
          success=true;
        System.out.println("terminate with: " + ExitVal);
        //return ExitVal;
        if(dm)
          {
            FlashLabel(jCloseButton);
            dispose();
          }
      }
      catch (Exception f)
      {
        System.out.println("Error: " + f.getMessage());
        //return ERROR;
      }
    }
  }

  public PhFitFrame_Messages(String c,boolean demomode) {
    try {
      command=c;
      dm=demomode;
      setLocation(100,100);
      setModal(true);
      setSize(400,300);
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }

  private void jbInit() throws Exception {
    this.addWindowListener(new java.awt.event.WindowAdapter() {
      public void windowOpened(WindowEvent e) {
        this_windowOpened(e);
      }
    });
    jCloseButton.setText("Close");
    jCloseButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jCloseButton_actionPerformed(e);
      }
    });
    jScrollPane1.setAutoscrolls(true);
    jScrollPane1.setMaximumSize(new Dimension(400, 300));
    jScrollPane1.setMinimumSize(new Dimension(400, 300));
    jScrollPane1.setPreferredSize(new Dimension(400, 300));
    this.getContentPane().add(jScrollPane1, BorderLayout.CENTER);
    this.getContentPane().add(jCloseButton,  BorderLayout.SOUTH);
    jScrollPane1.getViewport().add(jMessagesText, null);
  }


  void this_windowOpened(WindowEvent e) {
    Loader l = new Loader();
    l.start();
  }

  void jCloseButton_actionPerformed(ActionEvent e) {
    dispose();
  }
}