package v1;

import java.awt.*;
import javax.swing.*;
import javax.swing.border.*;
import java.awt.event.*;

/**
 * <p>Title: PhFit</p>
 * <p>Description: General Phase-Type Fitting Tool</p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: </p>
 * @author Andrs Horvth
 * @version 1.0
 */

public class OptionsDialog extends JDialog {
  JPanel jPanel1 = new JPanel();
  JTextArea jTextArea1 = new JTextArea();
  TitledBorder titledBorder1;
  JTextArea jTextArea2 = new JTextArea();
  JTextField jNUMBEROFROUNDSTextField = new JTextField();
  JTextArea jTextArea3 = new JTextArea();
  JTextField jNUMBEROFITERATIONSTextField = new JTextField();
  JTextArea jTextArea4 = new JTextArea();
  JTextArea jTextArea5 = new JTextArea();
  JTextField jNUMBEROFINTERVALSTextField = new JTextField();
  JTextArea jTextArea6 = new JTextArea();
  JTextArea jTextArea7 = new JTextArea();
  JTextArea jTextArea8 = new JTextArea();
  JButton jDefaultsOptionsButton = new JButton();

  static String DefaultNUMBEROFROUNDS="3";
  static String DefaultNUMBEROFITERATIONS="500";
  static String DefaultNUMBEROFINTERVALS="20";
  JButton jBackOptionsButton = new JButton();
  JButton jCancelOptionsButton1 = new JButton();

  public OptionsDialog(JFrame parent) {
    super(parent);
    try {
      setLocation(100,100);
      setModal(true);
      setSize(401,403);
      jbInit();
      jNUMBEROFROUNDSTextField.setText(Globals.NUMBEROFROUNDS);
      jNUMBEROFITERATIONSTextField.setText(Globals.NUMBEROFITERATIONS);
      jNUMBEROFINTERVALSTextField.setText(Globals.NUMBEROFINTERVALS);
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }
  private void jbInit() throws Exception {
    titledBorder1 = new TitledBorder("");
    this.getContentPane().setLayout(null);
    jPanel1.setBorder(BorderFactory.createEtchedBorder());
    jPanel1.setToolTipText("");
    jPanel1.setActionMap(null);
    jPanel1.setBounds(new Rectangle(3, 5, 389, 368));
    jPanel1.setLayout(null);
    jTextArea1.setBackground(Color.lightGray);
    jTextArea1.setBorder(null);
    jTextArea1.setDisabledTextColor(Color.lightGray);
    jTextArea1.setEditable(false);
    jTextArea1.setText("Number of times the fitting algorithm is run (then the best among " +
    "the resulting PH distributions is chosen):");
    jTextArea1.setLineWrap(true);
    jTextArea1.setWrapStyleWord(true);
    jTextArea1.setBounds(new Rectangle(12, 115, 271, 58));
    jTextArea2.setBackground(Color.lightGray);
    jTextArea2.setBorder(BorderFactory.createEtchedBorder());
    jTextArea2.setMinimumSize(new Dimension(0, 0));
    jTextArea2.setPreferredSize(new Dimension(0, 0));
    jTextArea2.setBounds(new Rectangle(6, 174, 377, 5));
    jNUMBEROFROUNDSTextField.setToolTipText("Number of rounds");
    jNUMBEROFROUNDSTextField.setBounds(new Rectangle(305, 149, 66, 18));
    jTextArea3.setBounds(new Rectangle(12, 185, 271, 38));
    jTextArea3.setWrapStyleWord(true);
    jTextArea3.setLineWrap(true);
    jTextArea3.setText("Number of times the parameters of the PH distribution are changed:");
    jTextArea3.setEditable(false);
    jTextArea3.setBorder(null);
    jTextArea3.setBackground(Color.lightGray);
    jNUMBEROFITERATIONSTextField.setToolTipText("Number of modifications in a round");
    jNUMBEROFITERATIONSTextField.setBounds(new Rectangle(305, 201, 66, 18));
    jTextArea4.setBounds(new Rectangle(6, 226, 377, 5));
    jTextArea4.setPreferredSize(new Dimension(0, 0));
    jTextArea4.setMinimumSize(new Dimension(0, 0));
    jTextArea4.setBorder(BorderFactory.createEtchedBorder());
    jTextArea4.setBackground(Color.lightGray);
    jTextArea5.setBackground(Color.lightGray);
    jTextArea5.setBorder(null);
    jTextArea5.setToolTipText("");
    jTextArea5.setEditable(false);
    jTextArea5.setText("Number of intervals for numerical integration used to calculate the " +
    "measure, in each interval 12 point Gaussian integral is performed " +
    "(applicable only to the continuous case):");
    jTextArea5.setLineWrap(true);
    jTextArea5.setWrapStyleWord(true);
    jTextArea5.setBounds(new Rectangle(12, 237, 288, 88));
    jNUMBEROFINTERVALSTextField.setToolTipText("Number of intervals for integration");
    jNUMBEROFINTERVALSTextField.setBounds(new Rectangle(305, 303, 66, 18));
    jTextArea6.setBackground(Color.lightGray);
    jTextArea6.setBorder(BorderFactory.createEtchedBorder());
    jTextArea6.setMinimumSize(new Dimension(0, 0));
    jTextArea6.setPreferredSize(new Dimension(0, 0));
    jTextArea6.setBounds(new Rectangle(6, 328, 377, 5));
    jTextArea7.setBounds(new Rectangle(11, 10, 367, 86));
    jTextArea7.setWrapStyleWord(true);
    jTextArea7.setLineWrap(true);
    jTextArea7.setText("Changing these parameters changes the goodness of the fitting. You " +
    "might want to modify them a bit to see the effect (increase in the " +
    "parameters might result in better fitting). Defaults can be loaded " +
    "anytime.");
    jTextArea7.setEditable(false);
    jTextArea7.setBorder(null);
    jTextArea7.setDisabledTextColor(Color.lightGray);
    jTextArea7.setBackground(Color.lightGray);
    jTextArea7.setFont(new java.awt.Font("Monospaced", 1, 12));
    jTextArea8.setBounds(new Rectangle(6, 104, 377, 5));
    jTextArea8.setPreferredSize(new Dimension(0, 0));
    jTextArea8.setMinimumSize(new Dimension(0, 0));
    jTextArea8.setBorder(BorderFactory.createEtchedBorder());
    jTextArea8.setBackground(Color.lightGray);
    jDefaultsOptionsButton.setText("Load Defaults");
    jDefaultsOptionsButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jDefaultsOptionsButton_actionPerformed(e);
      }
    });
    jDefaultsOptionsButton.setActionCommand("alma");
    jDefaultsOptionsButton.setBounds(new Rectangle(7, 338, 121, 23));
    jBackOptionsButton.setBounds(new Rectangle(261, 338, 121, 23));
    jBackOptionsButton.setActionCommand("alma");
    jBackOptionsButton.setText("Ok");
    jBackOptionsButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jBackOptionsButton_actionPerformed(e);
      }
    });
    this.setResizable(false);
    this.setTitle("Options");
    jCancelOptionsButton1.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jCancelOptionsButton1_actionPerformed(e);
      }
    });
    jCancelOptionsButton1.setText("Cancel");
    jCancelOptionsButton1.setActionCommand("alma");
    jCancelOptionsButton1.setBounds(new Rectangle(134, 338, 121, 23));
    jPanel1.add(jTextArea5, null);
    jPanel1.add(jTextArea1, null);
    jPanel1.add(jTextArea8, null);
    jPanel1.add(jTextArea2, null);
    jPanel1.add(jTextArea3, null);
    jPanel1.add(jTextArea4, null);
    jPanel1.add(jBackOptionsButton, null);
    jPanel1.add(jTextArea6, null);
    jPanel1.add(jDefaultsOptionsButton, null);
    jPanel1.add(jCancelOptionsButton1, null);
    jPanel1.add(jNUMBEROFROUNDSTextField, null);
    jPanel1.add(jNUMBEROFINTERVALSTextField, null);
    jPanel1.add(jNUMBEROFITERATIONSTextField, null);
    jPanel1.add(jTextArea7, null);
    this.getContentPane().add(jPanel1, null);
  }

  // Information to the user
  private void InfoPane(String m)
    {
      JOptionPane pane = new JOptionPane();
      JOptionPane.showMessageDialog(null,m,"Info",JOptionPane.INFORMATION_MESSAGE);
    }

  // Check if textfield contains a nice positive integer or not
  private int CheckIfInteger(JTextField tf)
    {
      try
        {
          Integer value=new Integer(Integer.parseInt(tf.getText()));
          if(value.intValue()>0) return 0;
        }
      catch (Exception e) {}
      InfoPane(tf.getToolTipText()+" should be a positive integer.");
      tf.grabFocus();
      tf.selectAll();
      return 1;
    }


  void jBackOptionsButton_actionPerformed(ActionEvent e) {
    int c;

    if((c=CheckIfInteger(jNUMBEROFROUNDSTextField))==1)
      return;
    if((c=CheckIfInteger(jNUMBEROFITERATIONSTextField))==1)
      return;
    if((c=CheckIfInteger(jNUMBEROFINTERVALSTextField))==1)
      return;

    Globals.NUMBEROFROUNDS=jNUMBEROFROUNDSTextField.getText();
    Globals.NUMBEROFITERATIONS=jNUMBEROFITERATIONSTextField.getText();
    Globals.NUMBEROFINTERVALS=jNUMBEROFINTERVALSTextField.getText();
    dispose();
  }

  void jDefaultsOptionsButton_actionPerformed(ActionEvent e) {
    jNUMBEROFROUNDSTextField.setText(DefaultNUMBEROFROUNDS);
    jNUMBEROFITERATIONSTextField.setText(DefaultNUMBEROFITERATIONS);
    jNUMBEROFINTERVALSTextField.setText(DefaultNUMBEROFINTERVALS);
  }

  void jCancelOptionsButton1_actionPerformed(ActionEvent e) {
    dispose();
  }
}