package v1;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;


/**
 * <p>Title: PhFit</p>
 * <p>Description: General Phase-Type Fitting Tool</p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: </p>
 * @author Andr\uFFFDs Horv\uFFFDth
 * @version 1.0
 */

public class PhFitFrame_Demo extends JDialog {
  JPanel jPanel1 = new JPanel();
  JLabel jDemoTypeLabel = new JLabel();
  JComboBox jDemoTypeCombo = new JComboBox();
  int wantdemo=0;

  static String[] DemoTypes = {
    "Continuous, by PDF","Discrete, by PDF",
    "Continuous, by samples","Discrete, by samples"};
  static String[] ContPDFDemos = {
    "Weibull","Lognormal","Uniform","Pareto I","Pareto II"};
  static String[] DiscPDFDemos = {
    "Weibull","Lognormal","Uniform","Pareto I","Pareto II"};
  static String[] ContSampleDemos = {
    "Dataset I", "Dataset II"};
  static String[] DiscSampleDemos = {
    "Dataset I", "Dataset II"};
  JLabel jDemoLabel = new JLabel();
  JComboBox jDemoCombo = new JComboBox();
  JTextArea jDemoText = new JTextArea();
  JButton jDemoGoButton = new JButton();

  public int DemoType_Demo()
  {
    return jDemoTypeCombo.getSelectedIndex();
  }

  public int Demo_Demo()
  {
    return jDemoCombo.getSelectedIndex();
  }

  public int WantDemo_Demo()
  {
    return wantdemo;
  }

  public PhFitFrame_Demo(JFrame parent) {
    super(parent);
    try {
      setLocation(100,100);
      setModal(true);
      setSize(247,270);
      jbInit();
    // Filling DemoTypeCombo with demotypes
    for (int i = 0; i < DemoTypes.length; i++)
      jDemoTypeCombo.addItem(DemoTypes[i]);
    // Filling DemoCombo with contPDFdemos
    jDemoCombo.removeAllItems();
    for (int i = 0; i < ContPDFDemos.length; i++)
      jDemoCombo.addItem(ContPDFDemos[i]);
    jDemoText.append("After You select the type of\n");
    jDemoText.append("the demo and the demo itself,\n");
    jDemoText.append("the input fields on the main\n");
    jDemoText.append("window will be filled\n");
    jDemoText.append("accordingly, the fitting will be\n");
    jDemoText.append("performed and the some results\n");
    jDemoText.append("will be visualized.\n");
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }
  private void jbInit() throws Exception {
    jDemoTypeCombo.setBounds(new Rectangle(97, 149, 130, 21));
    jDemoTypeCombo.addItemListener(new java.awt.event.ItemListener() {
      public void itemStateChanged(ItemEvent e) {
        jDemoTypeCombo_itemStateChanged(e);
      }
    });
    this.getContentPane().setLayout(null);
    jPanel1.setBorder(BorderFactory.createEtchedBorder());
    jPanel1.setBounds(new Rectangle(4, 4, 233, 236));
    jPanel1.setLayout(null);
    jDemoTypeLabel.setText("Type of Demo:");
    jDemoTypeLabel.setBounds(new Rectangle(13, 150, 102, 17));
    jDemoLabel.setBounds(new Rectangle(13, 176, 102, 17));
    jDemoLabel.setText("Demo:");
    jDemoCombo.setBounds(new Rectangle(98, 175, 129, 21));
    jDemoText.setBackground(Color.lightGray);
    jDemoText.setBorder(BorderFactory.createLoweredBevelBorder());
    jDemoText.setEditable(false);
    jDemoText.setBounds(new Rectangle(6, 5, 220, 138));
    jDemoGoButton.setBounds(new Rectangle(10, 202, 213, 25));
    jDemoGoButton.setToolTipText("");
    jDemoGoButton.setText("Start");
    jDemoGoButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jDemoGoButton_actionPerformed(e);
      }
    });
    this.setResizable(false);
    jPanel1.add(jDemoTypeLabel, null);
    jPanel1.add(jDemoTypeCombo, null);
    jPanel1.add(jDemoLabel, null);
    jPanel1.add(jDemoGoButton, null);
    jPanel1.add(jDemoText, null);
    jPanel1.add(jDemoCombo, null);
    this.getContentPane().add(jPanel1, null);
  }

  void jDemoTypeCombo_itemStateChanged(ItemEvent e) {
    jDemoCombo.removeAllItems();
    if(jDemoTypeCombo.getSelectedIndex()==0)
      {
       // Filling DemoCombo with contPDFdemos
       for (int i = 0; i < ContPDFDemos.length; i++)
         jDemoCombo.addItem(ContPDFDemos[i]);
      }
    if(jDemoTypeCombo.getSelectedIndex()==1)
      {
        // Filling DemoCombo with discPDFdemos
        for (int i = 0; i < DiscPDFDemos.length; i++)
          jDemoCombo.addItem(DiscPDFDemos[i]);
      }
    if(jDemoTypeCombo.getSelectedIndex()==2)
      {
        // Filling DemoCombo with ContSampledemos
        for (int i = 0; i < ContSampleDemos.length; i++)
          jDemoCombo.addItem(ContSampleDemos[i]);
      }
    if(jDemoTypeCombo.getSelectedIndex()==3)
      {
        // Filling DemoCombo with DiscSampledemos
        for (int i = 0; i < DiscSampleDemos.length; i++)
          jDemoCombo.addItem(DiscSampleDemos[i]);
      }
  }

  void jDemoGoButton_actionPerformed(ActionEvent e) {
    wantdemo=1;
    dispose();
  }
}